-- | Program Flow Control
module CsoundExpr.Opcodes.Control.Pgmctl
    (else',
     endif)
where



import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined



-- | * opcode : else
--  
--  
-- * syntax : 
--  
--  >   else
--  
--  
-- * description : 
--  
--  Executes a block of code when an "if...then" condition is false.
--  
--  
-- * url : <http://www.csounds.com/manual/html/else.html>
 
else' :: SignalOut
else' = outOpcode "else" args
  where args = []


-- | * opcode : endif
--  
--  
-- * syntax : 
--  
--  >   endif
--  
--  
-- * description : 
--  
--  Closes a block of code that begins with an "if...then"
-- statement.
--  
--  
-- * url : <http://www.csounds.com/manual/html/endif.html>
 
endif :: SignalOut
endif = outOpcode "endif" args
  where args = []