-- | System Realtime Messages
module CsoundExpr.Opcodes.Midi.Realtime
    (mclock,
     mrtmsg)
where



import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined



-- | * opcode : mclock
--  
--  
-- * syntax : 
--  
--  >   mclock ifreq
--  
--  
-- * description : 
--  
--  Sends a MIDI CLOCK message.
--  
--  
-- * url : <http://www.csounds.com/manual/html/mclock.html>
 
mclock :: Irate -> SignalOut
mclock i0freq = outOpcode "mclock" args
  where args = [to i0freq]


-- | * opcode : mrtmsg
--  
--  
-- * syntax : 
--  
--  >   mrtmsg imsgtype
--  
--  
-- * description : 
--  
--  Send system real-time messages to the MIDI OUT port.
--  
--  
-- * url : <http://www.csounds.com/manual/html/mrtmsg.html>
 
mrtmsg :: Irate -> SignalOut
mrtmsg i0msgtype = outOpcode "mrtmsg" args
  where args = [to i0msgtype]