-- | Waveguides
module CsoundExpr.Opcodes.Sigmod.Wavguide
    (streson)
where



import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined



-- | * opcode : streson
--  
--  
-- * syntax : 
--  
--  >   ares streson asig, kfr, ifdbgain
--  
--  
-- * description : 
--  
--  An audio signal is modified by a string resonator with variable
-- fundamental frequency.
--  
--  
-- * url : <http://www.csounds.com/manual/html/streson.html>
 
streson :: (K k0) => Arate -> k0 -> Irate -> Arate
streson a0sig k1fr i2fdbgain = opcode "streson" args
  where args = [to a0sig, to k1fr, to i2fdbgain]